Tool: evaluate_instances
Evaluates instances based on a given metric. Use this to perform online evaluation of model responses using metrics like fluency, coherence, safety, and more.
The following sample demonstrate how to use curl to invoke the evaluate_instances MCP tool.
| Curl Request |
|---|
curl --location 'https://aiplatform.googleapis.com/mcp/generate' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "evaluate_instances", "arguments": { // provide these details according to the tool's MCP specification } }, "jsonrpc": "2.0", "id": 1 }' |
Input Schema
Request message for EvaluationService.EvaluateInstances.
EvaluateInstancesRequest
| JSON representation |
|---|
{ "location": string, "metrics": [ { object ( |
| Fields | |
|---|---|
location |
Required. The resource name of the Location to evaluate the instances. Format: |
metrics[] |
The metrics used for evaluation. Currently, we only support evaluating a single metric. If multiple metrics are provided, only the first one will be evaluated. |
metricSources[] |
Optional. The metrics (either inline or registered) used for evaluation. Currently, we only support evaluating a single metric. If multiple metrics are provided, only the first one will be evaluated. |
instance |
The instance to be evaluated. |
autoraterConfig |
Optional. Autorater config used for evaluation. Not applicable for predefined metrics (PredefinedMetricSpec); the server uses its own model configuration for predefined metrics and this field is ignored. |
Union field metric_inputs. Instances and specs for evaluation metric_inputs can be only one of the following: |
|
exactMatchInput |
Auto metric instances. Instances and metric spec for exact match metric. |
bleuInput |
Instances and metric spec for bleu metric. |
rougeInput |
Instances and metric spec for rouge metric. |
fluencyInput |
LLM-based metric instance. General text generation metrics, applicable to other categories. Input for fluency metric. |
coherenceInput |
Input for coherence metric. |
safetyInput |
Input for safety metric. |
groundednessInput |
Input for groundedness metric. |
fulfillmentInput |
Input for fulfillment metric. |
summarizationQualityInput |
Input for summarization quality metric. |
pairwiseSummarizationQualityInput |
Input for pairwise summarization quality metric. |
summarizationHelpfulnessInput |
Input for summarization helpfulness metric. |
summarizationVerbosityInput |
Input for summarization verbosity metric. |
questionAnsweringQualityInput |
Input for question answering quality metric. |
pairwiseQuestionAnsweringQualityInput |
Input for pairwise question answering quality metric. |
questionAnsweringRelevanceInput |
Input for question answering relevance metric. |
questionAnsweringHelpfulnessInput |
Input for question answering helpfulness metric. |
questionAnsweringCorrectnessInput |
Input for question answering correctness metric. |
pointwiseMetricInput |
Input for pointwise metric. |
pairwiseMetricInput |
Input for pairwise metric. |
toolCallValidInput |
Tool call metric instances. Input for tool call valid metric. |
toolNameMatchInput |
Input for tool name match metric. |
toolParameterKeyMatchInput |
Input for tool parameter key match metric. |
toolParameterKvMatchInput |
Input for tool parameter key value match metric. |
cometInput |
Translation metrics. Input for Comet metric. |
metricxInput |
Input for Metricx metric. |
trajectoryExactMatchInput |
Input for trajectory exact match metric. |
trajectoryInOrderMatchInput |
Input for trajectory in order match metric. |
trajectoryAnyOrderMatchInput |
Input for trajectory match any order metric. |
trajectoryPrecisionInput |
Input for trajectory precision metric. |
trajectoryRecallInput |
Input for trajectory recall metric. |
trajectorySingleToolUseInput |
Input for trajectory single tool use metric. |
rubricBasedInstructionFollowingInput |
Rubric Based Instruction Following metric. |
ExactMatchInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for exact match metric. |
instances[] |
Required. Repeated exact match instances. |
ExactMatchInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Required. Ground truth used to compare against the prediction. |
BleuInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for bleu score metric. |
instances[] |
Required. Repeated bleu instances. |
BleuSpec
| JSON representation |
|---|
{ "useEffectiveOrder": boolean } |
| Fields | |
|---|---|
useEffectiveOrder |
Optional. Whether to use_effective_order to compute bleu score. |
BleuInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Required. Ground truth used to compare against the prediction. |
RougeInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for rouge score metric. |
instances[] |
Required. Repeated rouge instances. |
RougeSpec
| JSON representation |
|---|
{ "rougeType": string, "useStemmer": boolean, "splitSummaries": boolean } |
| Fields | |
|---|---|
rougeType |
Optional. Supported rouge types are rougen[1-9], rougeL, and rougeLsum. |
useStemmer |
Optional. Whether to use stemmer to compute rouge score. |
splitSummaries |
Optional. Whether to split summaries while using rougeLsum. |
RougeInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Required. Ground truth used to compare against the prediction. |
FluencyInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for fluency score metric. |
instance |
Required. Fluency instance. |
FluencySpec
| JSON representation |
|---|
{ "version": integer } |
| Fields | |
|---|---|
version |
Optional. Which version to use for evaluation. |
FluencyInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
CoherenceInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for coherence score metric. |
instance |
Required. Coherence instance. |
CoherenceSpec
| JSON representation |
|---|
{ "version": integer } |
| Fields | |
|---|---|
version |
Optional. Which version to use for evaluation. |
CoherenceInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
SafetyInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for safety metric. |
instance |
Required. Safety instance. |
SafetySpec
| JSON representation |
|---|
{ "version": integer } |
| Fields | |
|---|---|
version |
Optional. Which version to use for evaluation. |
SafetyInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
GroundednessInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for groundedness metric. |
instance |
Required. Groundedness instance. |
GroundednessSpec
| JSON representation |
|---|
{ "version": integer } |
| Fields | |
|---|---|
version |
Optional. Which version to use for evaluation. |
GroundednessInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
context |
Required. Background information provided in context used to compare against the prediction. |
FulfillmentInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for fulfillment score metric. |
instance |
Required. Fulfillment instance. |
FulfillmentSpec
| JSON representation |
|---|
{ "version": integer } |
| Fields | |
|---|---|
version |
Optional. Which version to use for evaluation. |
FulfillmentInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
instruction |
Required. Inference instruction prompt to compare prediction with. |
SummarizationQualityInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for summarization quality score metric. |
instance |
Required. Summarization quality instance. |
SummarizationQualitySpec
| JSON representation |
|---|
{ "useReference": boolean, "version": integer } |
| Fields | |
|---|---|
useReference |
Optional. Whether to use instance.reference to compute summarization quality. |
version |
Optional. Which version to use for evaluation. |
SummarizationQualityInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Optional. Ground truth used to compare against the prediction. |
Union field
|
|
context |
Required. Text to be summarized. |
Union field
|
|
instruction |
Required. Summarization prompt for LLM. |
PairwiseSummarizationQualityInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for pairwise summarization quality score metric. |
instance |
Required. Pairwise summarization quality instance. |
PairwiseSummarizationQualitySpec
| JSON representation |
|---|
{ "useReference": boolean, "version": integer } |
| Fields | |
|---|---|
useReference |
Optional. Whether to use instance.reference to compute pairwise summarization quality. |
version |
Optional. Which version to use for evaluation. |
PairwiseSummarizationQualityInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the candidate model. |
Union field
|
|
baselinePrediction |
Required. Output of the baseline model. |
Union field
|
|
reference |
Optional. Ground truth used to compare against the prediction. |
Union field
|
|
context |
Required. Text to be summarized. |
Union field
|
|
instruction |
Required. Summarization prompt for LLM. |
SummarizationHelpfulnessInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for summarization helpfulness score metric. |
instance |
Required. Summarization helpfulness instance. |
SummarizationHelpfulnessSpec
| JSON representation |
|---|
{ "useReference": boolean, "version": integer } |
| Fields | |
|---|---|
useReference |
Optional. Whether to use instance.reference to compute summarization helpfulness. |
version |
Optional. Which version to use for evaluation. |
SummarizationHelpfulnessInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Optional. Ground truth used to compare against the prediction. |
Union field
|
|
context |
Required. Text to be summarized. |
Union field
|
|
instruction |
Optional. Summarization prompt for LLM. |
SummarizationVerbosityInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for summarization verbosity score metric. |
instance |
Required. Summarization verbosity instance. |
SummarizationVerbositySpec
| JSON representation |
|---|
{ "useReference": boolean, "version": integer } |
| Fields | |
|---|---|
useReference |
Optional. Whether to use instance.reference to compute summarization verbosity. |
version |
Optional. Which version to use for evaluation. |
SummarizationVerbosityInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Optional. Ground truth used to compare against the prediction. |
Union field
|
|
context |
Required. Text to be summarized. |
Union field
|
|
instruction |
Optional. Summarization prompt for LLM. |
QuestionAnsweringQualityInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for question answering quality score metric. |
instance |
Required. Question answering quality instance. |
QuestionAnsweringQualitySpec
| JSON representation |
|---|
{ "useReference": boolean, "version": integer } |
| Fields | |
|---|---|
useReference |
Optional. Whether to use instance.reference to compute question answering quality. |
version |
Optional. Which version to use for evaluation. |
QuestionAnsweringQualityInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Optional. Ground truth used to compare against the prediction. |
Union field
|
|
context |
Required. Text to answer the question. |
Union field
|
|
instruction |
Required. Question Answering prompt for LLM. |
PairwiseQuestionAnsweringQualityInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for pairwise question answering quality score metric. |
instance |
Required. Pairwise question answering quality instance. |
PairwiseQuestionAnsweringQualitySpec
| JSON representation |
|---|
{ "useReference": boolean, "version": integer } |
| Fields | |
|---|---|
useReference |
Optional. Whether to use instance.reference to compute question answering quality. |
version |
Optional. Which version to use for evaluation. |
PairwiseQuestionAnsweringQualityInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the candidate model. |
Union field
|
|
baselinePrediction |
Required. Output of the baseline model. |
Union field
|
|
reference |
Optional. Ground truth used to compare against the prediction. |
Union field
|
|
context |
Required. Text to answer the question. |
Union field
|
|
instruction |
Required. Question Answering prompt for LLM. |
QuestionAnsweringRelevanceInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for question answering relevance score metric. |
instance |
Required. Question answering relevance instance. |
QuestionAnsweringRelevanceSpec
| JSON representation |
|---|
{ "useReference": boolean, "version": integer } |
| Fields | |
|---|---|
useReference |
Optional. Whether to use instance.reference to compute question answering relevance. |
version |
Optional. Which version to use for evaluation. |
QuestionAnsweringRelevanceInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Optional. Ground truth used to compare against the prediction. |
Union field
|
|
context |
Optional. Text provided as context to answer the question. |
Union field
|
|
instruction |
Required. The question asked and other instruction in the inference prompt. |
QuestionAnsweringHelpfulnessInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for question answering helpfulness score metric. |
instance |
Required. Question answering helpfulness instance. |
QuestionAnsweringHelpfulnessSpec
| JSON representation |
|---|
{ "useReference": boolean, "version": integer } |
| Fields | |
|---|---|
useReference |
Optional. Whether to use instance.reference to compute question answering helpfulness. |
version |
Optional. Which version to use for evaluation. |
QuestionAnsweringHelpfulnessInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Optional. Ground truth used to compare against the prediction. |
Union field
|
|
context |
Optional. Text provided as context to answer the question. |
Union field
|
|
instruction |
Required. The question asked and other instruction in the inference prompt. |
QuestionAnsweringCorrectnessInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for question answering correctness score metric. |
instance |
Required. Question answering correctness instance. |
QuestionAnsweringCorrectnessSpec
| JSON representation |
|---|
{ "useReference": boolean, "version": integer } |
| Fields | |
|---|---|
useReference |
Optional. Whether to use instance.reference to compute question answering correctness. |
version |
Optional. Which version to use for evaluation. |
QuestionAnsweringCorrectnessInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Optional. Ground truth used to compare against the prediction. |
Union field
|
|
context |
Optional. Text provided as context to answer the question. |
Union field
|
|
instruction |
Required. The question asked and other instruction in the inference prompt. |
PointwiseMetricInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for pointwise metric. |
instance |
Required. Pointwise metric instance. |
PointwiseMetricSpec
| JSON representation |
|---|
{ "customOutputFormatConfig": { object ( |
| Fields | |
|---|---|
customOutputFormatConfig |
Optional. CustomOutputFormatConfig allows customization of metric output. By default, metrics return a score and explanation. When this config is set, the default output is replaced with either: - The raw output string. - A parsed output based on a user-defined schema. If a custom format is chosen, the |
Union field
|
|
metricPromptTemplate |
Required. Metric prompt template for pointwise metric. |
Union field
|
|
systemInstruction |
Optional. System instructions for pointwise metric. |
CustomOutputFormatConfig
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field custom_output_format_config. Custom output format configuration. custom_output_format_config can be only one of the following: |
|
returnRawOutput |
Optional. Whether to return raw output. |
PointwiseMetricInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field instance. Instance for pointwise metric. instance can be only one of the following: |
|
jsonInstance |
Instance specified as a json string. String key-value pairs are expected in the json_instance to render PointwiseMetricSpec.instance_prompt_template. |
contentMapInstance |
Key-value contents for the mutlimodality input, including text, image, video, audio, and pdf, etc. The key is placeholder in metric prompt template, and the value is the multimodal content. |
ContentMap
| JSON representation |
|---|
{
"values": {
string: {
object ( |
| Fields | |
|---|---|
values |
Optional. Map of placeholder to contents. An object containing a list of |
ValuesEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
Contents
| JSON representation |
|---|
{
"contents": [
{
object ( |
| Fields | |
|---|---|
contents[] |
Optional. Repeated contents. |
Content
| JSON representation |
|---|
{
"role": string,
"parts": [
{
object ( |
| Fields | |
|---|---|
role |
Optional. The producer of the content. Must be either 'user' or 'model'. If not set, the service will default to 'user'. |
parts[] |
Required. A list of A |
Part
| JSON representation |
|---|
{ "thought": boolean, "thoughtSignature": string, "mediaResolution": { object ( |
| Fields | |
|---|---|
thought |
Optional. Indicates whether the |
thoughtSignature |
Optional. An opaque signature for the thought so it can be reused in subsequent requests. A base64-encoded string. |
mediaResolution |
per part media resolution. Media resolution for the input media. |
audioTranscription |
Optional. Audio (input or output) transcription. This is only set when this Part contains audio data. |
Union field
|
|
text |
Optional. The text content of the part. When sent from the VSCode Gemini Code Assist extension, references to @mentioned items will be converted to markdown boldface text. For example |
inlineData |
Optional. The inline data content of the part. This can be used to include images, audio, or video in a request. |
fileData |
Optional. The URI-based data of the part. This can be used to include files from Google Cloud Storage. |
functionCall |
Optional. A predicted function call returned from the model. This contains the name of the function to call and the arguments to pass to the function. |
functionResponse |
Optional. The result of a function call. This is used to provide the model with the result of a function call that it predicted. |
executableCode |
Optional. Code generated by the model that is intended to be executed. |
codeExecutionResult |
Optional. The result of executing the |
Union field
|
|
videoMetadata |
Optional. Video metadata. The metadata should only be specified while the video data is presented in inline_data or file_data. |
Blob
| JSON representation |
|---|
{ "mimeType": string, "data": string, "displayName": string } |
| Fields | |
|---|---|
mimeType |
Required. The IANA standard MIME type of the source data. |
data |
Required. The raw bytes of the data. A base64-encoded string. |
displayName |
Optional. The display name of the blob. Used to provide a label or filename to distinguish blobs. This field is only returned in |
FileData
| JSON representation |
|---|
{ "mimeType": string, "fileUri": string, "displayName": string } |
| Fields | |
|---|---|
mimeType |
Required. The IANA standard MIME type of the source data. |
fileUri |
Required. The URI of the file in Google Cloud Storage. |
displayName |
Optional. The display name of the file. Used to provide a label or filename to distinguish files. This field is only returned in |
FunctionCall
| JSON representation |
|---|
{
"id": string,
"name": string,
"args": {
object
},
"partialArgs": [
{
object ( |
| Fields | |
|---|---|
id |
Optional. The unique id of the function call. If populated, the client to execute the |
name |
Optional. The name of the function to call. Matches |
args |
Optional. The function parameters and values in JSON object format. See |
partialArgs[] |
Optional. The partial argument value of the function call. If provided, represents the arguments/fields that are streamed incrementally. |
willContinue |
Optional. Whether this is the last part of the FunctionCall. If true, another partial message for the current FunctionCall is expected to follow. |
Struct
| JSON representation |
|---|
{ "fields": { string: value, ... } } |
| Fields | |
|---|---|
fields |
Unordered map of dynamically typed values. An object containing a list of |
FieldsEntry
| JSON representation |
|---|
{ "key": string, "value": value } |
| Fields | |
|---|---|
key |
|
value |
|
Value
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field kind. The kind of value. kind can be only one of the following: |
|
nullValue |
Represents a JSON |
numberValue |
Represents a JSON number. Must not be |
stringValue |
Represents a JSON string. |
boolValue |
Represents a JSON boolean ( |
structValue |
Represents a JSON object. |
listValue |
Represents a JSON array. |
ListValue
| JSON representation |
|---|
{ "values": [ value ] } |
| Fields | |
|---|---|
values[] |
Repeated field of dynamically typed values. |
PartialArg
| JSON representation |
|---|
{ "jsonPath": string, "willContinue": boolean, // Union field |
| Fields | |
|---|---|
jsonPath |
Required. A JSON Path (RFC 9535) to the argument being streamed. https://datatracker.ietf.org/doc/html/rfc9535. e.g. "$.foo.bar[0].data". |
willContinue |
Optional. Whether this is not the last part of the same json_path. If true, another PartialArg message for the current json_path is expected to follow. |
Union field delta. The delta of field value being streamed. delta can be only one of the following: |
|
nullValue |
Optional. Represents a null value. |
numberValue |
Optional. Represents a double value. |
stringValue |
Optional. Represents a string value. |
boolValue |
Optional. Represents a boolean value. |
FunctionResponse
| JSON representation |
|---|
{
"id": string,
"name": string,
"response": {
object
},
"parts": [
{
object ( |
| Fields | |
|---|---|
id |
Optional. The id of the function call this response is for. Populated by the client to match the corresponding function call |
name |
Required. The name of the function to call. Matches |
response |
Required. The function response in JSON object format. Use "output" key to specify function output and "error" key to specify error details (if any). If "output" and "error" keys are not specified, then whole "response" is treated as function output. |
parts[] |
Optional. Ordered |
FunctionResponsePart
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field data. The data of the function response part. data can be only one of the following: |
|
inlineData |
Inline media bytes. |
fileData |
URI based data. |
FunctionResponseBlob
| JSON representation |
|---|
{ "mimeType": string, "data": string, "displayName": string } |
| Fields | |
|---|---|
mimeType |
Required. The IANA standard MIME type of the source data. |
data |
Required. Raw bytes. A base64-encoded string. |
displayName |
Optional. Display name of the blob. Used to provide a label or filename to distinguish blobs. This field is only returned in PromptMessage for prompt management. It is currently used in the Gemini GenerateContent calls only when server side tools (code_execution, google_search, and url_context) are enabled. |
FunctionResponseFileData
| JSON representation |
|---|
{ "mimeType": string, "fileUri": string, "displayName": string } |
| Fields | |
|---|---|
mimeType |
Required. The IANA standard MIME type of the source data. |
fileUri |
Required. URI. |
displayName |
Optional. Display name of the file data. Used to provide a label or filename to distinguish file datas. This field is only returned in PromptMessage for prompt management. It is currently used in the Gemini GenerateContent calls only when server side tools (code_execution, google_search, and url_context) are enabled. |
ExecutableCode
| JSON representation |
|---|
{ "language": enum ( |
| Fields | |
|---|---|
language |
Required. Programming language of the |
code |
Required. The code to be executed. |
Union field
|
|
id |
Optional. Unique identifier of the |
CodeExecutionResult
| JSON representation |
|---|
{ "outcome": enum ( |
| Fields | |
|---|---|
outcome |
Required. Outcome of the code execution. |
output |
Optional. Contains stdout when code execution is successful, stderr or other description otherwise. |
Union field
|
|
id |
Optional. The identifier of the |
VideoMetadata
| JSON representation |
|---|
{ "startOffset": string, "endOffset": string, "fps": number } |
| Fields | |
|---|---|
startOffset |
Optional. The start offset of the video. A duration in seconds with up to nine fractional digits, ending with ' |
endOffset |
Optional. The end offset of the video. A duration in seconds with up to nine fractional digits, ending with ' |
fps |
Optional. The frame rate of the video sent to the model. If not specified, the default value is 1.0. The valid range is (0.0, 24.0]. |
Duration
| JSON representation |
|---|
{ "seconds": string, "nanos": integer } |
| Fields | |
|---|---|
seconds |
Signed seconds of the span of time. Must be from -315,576,000,000 to +315,576,000,000 inclusive. Note: these bounds are computed from: 60 sec/min * 60 min/hr * 24 hr/day * 365.25 days/year * 10000 years |
nanos |
Signed fractions of a second at nanosecond resolution of the span of time. Durations less than one second are represented with a 0 |
MediaResolution
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
level |
The tokenization quality used for given media. |
AudioTranscription
| JSON representation |
|---|
{
"text": string,
"speakerLabel": string,
"words": [
{
object ( |
| Fields | |
|---|---|
text |
Required. The transcription text of this audio segment. |
speakerLabel |
Optional. A label identifying the speaker of this audio segment (e.g. "spk_1", "spk_2"). Present when diarization is set. |
words[] |
Optional. Detailed word-level transcriptions and timing details. Present when word_timestamp is set. |
WordInfo
| JSON representation |
|---|
{ "word": string, "startOffset": string, "endOffset": string } |
| Fields | |
|---|---|
word |
Required. Transcript of the word. |
startOffset |
Optional. Start offset in time of the word relative to the start of the audio. A duration in seconds with up to nine fractional digits, ending with ' |
endOffset |
Optional. End offset in time of the word relative to the start of the audio. A duration in seconds with up to nine fractional digits, ending with ' |
PairwiseMetricInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for pairwise metric. |
instance |
Required. Pairwise metric instance. |
PairwiseMetricSpec
| JSON representation |
|---|
{ "candidateResponseFieldName": string, "baselineResponseFieldName": string, "customOutputFormatConfig": { object ( |
| Fields | |
|---|---|
candidateResponseFieldName |
Optional. The field name of the candidate response. |
baselineResponseFieldName |
Optional. The field name of the baseline response. |
customOutputFormatConfig |
Optional. CustomOutputFormatConfig allows customization of metric output. When this config is set, the default output is replaced with the raw output string. If a custom format is chosen, the |
Union field
|
|
metricPromptTemplate |
Required. Metric prompt template for pairwise metric. |
Union field
|
|
systemInstruction |
Optional. System instructions for pairwise metric. |
PairwiseMetricInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field instance. Instance for pairwise metric. instance can be only one of the following: |
|
jsonInstance |
Instance specified as a json string. String key-value pairs are expected in the json_instance to render PairwiseMetricSpec.instance_prompt_template. |
contentMapInstance |
Key-value contents for the mutlimodality input, including text, image, video, audio, and pdf, etc. The key is placeholder in metric prompt template, and the value is the multimodal content. |
ToolCallValidInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for tool call valid metric. |
instances[] |
Required. Repeated tool call valid instances. |
ToolCallValidInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Required. Ground truth used to compare against the prediction. |
ToolNameMatchInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for tool name match metric. |
instances[] |
Required. Repeated tool name match instances. |
ToolNameMatchInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Required. Ground truth used to compare against the prediction. |
ToolParameterKeyMatchInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for tool parameter key match metric. |
instances[] |
Required. Repeated tool parameter key match instances. |
ToolParameterKeyMatchInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Required. Ground truth used to compare against the prediction. |
ToolParameterKVMatchInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for tool parameter key value match metric. |
instances[] |
Required. Repeated tool parameter key value match instances. |
ToolParameterKVMatchSpec
| JSON representation |
|---|
{ "useStrictStringMatch": boolean } |
| Fields | |
|---|---|
useStrictStringMatch |
Optional. Whether to use STRICT string match on parameter values. |
ToolParameterKVMatchInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Required. Ground truth used to compare against the prediction. |
CometInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for comet metric. |
instance |
Required. Comet instance. |
CometSpec
| JSON representation |
|---|
{ "sourceLanguage": string, "targetLanguage": string, // Union field |
| Fields | |
|---|---|
sourceLanguage |
Optional. Source language in BCP-47 format. |
targetLanguage |
Optional. Target language in BCP-47 format. Covers both prediction and reference. |
Union field
|
|
version |
Required. Which version to use for evaluation. |
CometInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Optional. Ground truth used to compare against the prediction. |
Union field
|
|
source |
Optional. Source text in original language. |
MetricxInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for Metricx metric. |
instance |
Required. Metricx instance. |
MetricxSpec
| JSON representation |
|---|
{ "sourceLanguage": string, "targetLanguage": string, // Union field |
| Fields | |
|---|---|
sourceLanguage |
Optional. Source language in BCP-47 format. |
targetLanguage |
Optional. Target language in BCP-47 format. Covers both prediction and reference. |
Union field
|
|
version |
Required. Which version to use for evaluation. |
MetricxInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
prediction |
Required. Output of the evaluated model. |
Union field
|
|
reference |
Optional. Ground truth used to compare against the prediction. |
Union field
|
|
source |
Optional. Source text in original language. |
TrajectoryExactMatchInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for TrajectoryExactMatch metric. |
instances[] |
Required. Repeated TrajectoryExactMatch instance. |
TrajectoryExactMatchInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
predictedTrajectory |
Required. Spec for predicted tool call trajectory. |
Union field
|
|
referenceTrajectory |
Required. Spec for reference tool call trajectory. |
Trajectory
| JSON representation |
|---|
{
"toolCalls": [
{
object ( |
| Fields | |
|---|---|
toolCalls[] |
Required. Tool calls in the trajectory. |
ToolCall
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
toolName |
Required. Spec for tool name |
Union field
|
|
toolInput |
Optional. Spec for tool input |
TrajectoryInOrderMatchInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for TrajectoryInOrderMatch metric. |
instances[] |
Required. Repeated TrajectoryInOrderMatch instance. |
TrajectoryInOrderMatchInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
predictedTrajectory |
Required. Spec for predicted tool call trajectory. |
Union field
|
|
referenceTrajectory |
Required. Spec for reference tool call trajectory. |
TrajectoryAnyOrderMatchInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for TrajectoryAnyOrderMatch metric. |
instances[] |
Required. Repeated TrajectoryAnyOrderMatch instance. |
TrajectoryAnyOrderMatchInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
predictedTrajectory |
Required. Spec for predicted tool call trajectory. |
Union field
|
|
referenceTrajectory |
Required. Spec for reference tool call trajectory. |
TrajectoryPrecisionInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for TrajectoryPrecision metric. |
instances[] |
Required. Repeated TrajectoryPrecision instance. |
TrajectoryPrecisionInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
predictedTrajectory |
Required. Spec for predicted tool call trajectory. |
Union field
|
|
referenceTrajectory |
Required. Spec for reference tool call trajectory. |
TrajectoryRecallInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for TrajectoryRecall metric. |
instances[] |
Required. Repeated TrajectoryRecall instance. |
TrajectoryRecallInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
predictedTrajectory |
Required. Spec for predicted tool call trajectory. |
Union field
|
|
referenceTrajectory |
Required. Spec for reference tool call trajectory. |
TrajectorySingleToolUseInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for TrajectorySingleToolUse metric. |
instances[] |
Required. Repeated TrajectorySingleToolUse instance. |
TrajectorySingleToolUseSpec
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
toolName |
Required. Spec for tool name to be checked for in the predicted trajectory. |
TrajectorySingleToolUseInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
predictedTrajectory |
Required. Spec for predicted tool call trajectory. |
RubricBasedInstructionFollowingInput
| JSON representation |
|---|
{ "metricSpec": { object ( |
| Fields | |
|---|---|
metricSpec |
Required. Spec for RubricBasedInstructionFollowing metric. |
instance |
Required. Instance for RubricBasedInstructionFollowing metric. |
RubricBasedInstructionFollowingInstance
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field instance. Instance for RubricBasedInstructionFollowing metric. instance can be only one of the following: |
|
jsonInstance |
Required. Instance specified as a json string. String key-value pairs are expected in the json_instance to render RubricBasedInstructionFollowing prompt templates. |
Metric
| JSON representation |
|---|
{ "aggregationMetrics": [ enum ( |
| Fields | |
|---|---|
aggregationMetrics[] |
Optional. The aggregation metrics to use. |
metadata |
Optional. Metadata about the metric, used for visualization and organization. |
Union field metric_spec. The spec for the metric. It would be either a pre-defined metric, or a inline metric spec. metric_spec can be only one of the following: |
|
predefinedMetricSpec |
The spec for a pre-defined metric. |
computationBasedMetricSpec |
Spec for a computation based metric. |
llmBasedMetricSpec |
Spec for an LLM based metric. |
customCodeExecutionSpec |
Spec for Custom Code Execution metric. |
pointwiseMetricSpec |
Spec for pointwise metric. |
pairwiseMetricSpec |
Spec for pairwise metric. |
exactMatchSpec |
Spec for exact match metric. |
bleuSpec |
Spec for bleu metric. |
rougeSpec |
Spec for rouge metric. |
PredefinedMetricSpec
| JSON representation |
|---|
{ "metricSpecName": string, "metricSpecParameters": { object } } |
| Fields | |
|---|---|
metricSpecName |
Required. The name of a pre-defined metric, such as "instruction_following_v1" or "text_quality_v1". |
metricSpecParameters |
Optional. The parameters needed to run the pre-defined metric. |
ComputationBasedMetricSpec
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
type |
Required. The type of the computation based metric. |
Union field
|
|
parameters |
Optional. A map of parameters for the metric, e.g. {"rouge_type": "rougeL"}. |
LLMBasedMetricSpec
| JSON representation |
|---|
{ "resultParserConfig": { object ( |
| Fields | |
|---|---|
resultParserConfig |
Optional. The parser config for the metric result. |
Union field rubrics_source. Source of the rubrics to be used for evaluation. rubrics_source can be only one of the following: |
|
rubricGroupKey |
Use a pre-defined group of rubrics associated with the input. Refers to a key in the rubric_groups map of EvaluationInstance. |
rubricGenerationSpec |
Dynamically generate rubrics using this specification. |
predefinedRubricGenerationSpec |
Dynamically generate rubrics using a predefined spec. |
Union field
|
|
metricPromptTemplate |
Required. Template for the prompt sent to the judge model. |
Union field
|
|
systemInstruction |
Optional. System instructions for the judge model. |
Union field
|
|
judgeAutoraterConfig |
Optional. Optional configuration for the judge LLM (Autorater). |
Union field
|
|
additionalConfig |
Optional. Optional additional configuration for the metric. |
RubricGenerationSpec
| JSON representation |
|---|
{ "promptTemplate": string, "rubricContentType": enum ( |
| Fields | |
|---|---|
promptTemplate |
Template for the prompt used to generate rubrics. The details should be updated based on the most-recent recipe requirements. |
rubricContentType |
The type of rubric content to be generated. |
rubricTypeOntology[] |
Optional. An optional, pre-defined list of allowed types for generated rubrics. If this field is provided, it implies |
Union field
|
|
modelConfig |
Configuration for the model used in rubric generation. Configs including sampling count and base model can be specified here. Flipping is not supported for rubric generation. |
AutoraterConfig
| JSON representation |
|---|
{ "autoraterModel": string, "generationConfig": { object ( |
| Fields | |
|---|---|
autoraterModel |
Optional. The fully qualified name of the publisher model or tuned autorater endpoint to use. Publisher model format: Tuned model endpoint format: |
generationConfig |
Optional. Configuration options for model generation and outputs. |
Union field
|
|
samplingCount |
Optional. Number of samples for each instance in the dataset. If not specified, the default is 4. Minimum value is 1, maximum value is 32. |
Union field
|
|
flipEnabled |
Optional. Default is true. Whether to flip the candidate and baseline responses. This is only applicable to the pairwise metric. If enabled, also provide PairwiseMetricSpec.candidate_response_field_name and PairwiseMetricSpec.baseline_response_field_name. When rendering PairwiseMetricSpec.metric_prompt_template, the candidate and baseline fields will be flipped for half of the samples to reduce bias. |
GenerationConfig
| JSON representation |
|---|
{ "stopSequences": [ string ], "responseMimeType": string, "responseModalities": [ enum ( |
| Fields | |
|---|---|
stopSequences[] |
Optional. A list of character sequences that will stop the model from generating further tokens. If a stop sequence is generated, the output will end at that point. This is useful for controlling the length and structure of the output. For example, you can use ["\n", "###"] to stop generation at a new line or a specific marker. |
responseMimeType |
Optional. The IANA standard MIME type of the response. The model will generate output that conforms to this MIME type. Supported values include 'text/plain' (default) and 'application/json'. The model needs to be prompted to output the appropriate response type, otherwise the behavior is undefined. Deprecated: Use |
responseModalities[] |
Optional. The modalities of the response. The model will generate a response that includes all the specified modalities. For example, if this is set to |
thinkingConfig |
Optional. Configuration for thinking features. An error will be returned if this field is set for models that don't support thinking. |
modelConfig |
Optional. Config for model selection. |
responseFormat[] |
Optional. New response format field for the model to configure output formatting and delivery. |
Union field
|
|
temperature |
Optional. Controls the randomness of the output. A higher temperature results in more creative and diverse responses, while a lower temperature makes the output more predictable and focused. The valid range is (0.0, 2.0]. |
Union field
|
|
topP |
Optional. Specifies the nucleus sampling threshold. The model considers only the smallest set of tokens whose cumulative probability is at least |
Union field
|
|
topK |
Optional. Specifies the top-k sampling threshold. The model considers only the top k most probable tokens for the next token. This can be useful for generating more coherent and less random text. For example, a |
Union field
|
|
candidateCount |
Optional. The number of candidate responses to generate. A higher |
Union field
|
|
maxOutputTokens |
Optional. The maximum number of tokens to generate in the response. A token is approximately four characters. The default value varies by model. This parameter can be used to control the length of the generated text and prevent overly long responses. |
Union field
|
|
responseLogprobs |
Optional. If set to true, the log probabilities of the output tokens are returned. Log probabilities are the logarithm of the probability of a token appearing in the output. A higher log probability means the token is more likely to be generated. This can be useful for analyzing the model's confidence in its own output and for debugging. |
Union field
|
|
logprobs |
Optional. The number of top log probabilities to return for each token. This can be used to see which other tokens were considered likely candidates for a given position. A higher value will return more options, but it will also increase the size of the response. |
Union field
|
|
presencePenalty |
Optional. Penalizes tokens that have already appeared in the generated text. A positive value encourages the model to generate more diverse and less repetitive text. Valid values can range from [-2.0, 2.0]. |
Union field
|
|
frequencyPenalty |
Optional. Penalizes tokens based on their frequency in the generated text. A positive value helps to reduce the repetition of words and phrases. Valid values can range from [-2.0, 2.0]. |
Union field
|
|
seed |
Optional. A seed for the random number generator. By setting a seed, you can make the model's output mostly deterministic. For a given prompt and parameters (like temperature, top_p, etc.), the model will produce the same response every time. However, it's not a guaranteed absolute deterministic behavior. This is different from parameters like |
Union field
|
|
responseSchema |
Optional. Lets you to specify a schema for the model's response, ensuring that the output conforms to a particular structure. This is useful for generating structured data such as JSON. The schema is a subset of the OpenAPI 3.0 schema object object. When this field is set, you must also set the |
Union field
|
|
responseJsonSchema |
Optional. When this field is set, |
Union field
|
|
routingConfig |
Optional. Routing configuration. |
Union field
|
|
audioTimestamp |
Optional. If enabled, audio timestamps will be included in the request to the model. This can be useful for synchronizing audio with other modalities in the response. |
Union field
|
|
mediaResolution |
Optional. The token resolution at which input media content is sampled. This is used to control the trade-off between the quality of the response and the number of tokens used to represent the media. A higher resolution allows the model to perceive more detail, which can lead to a more nuanced response, but it will also use more tokens. This does not affect the image dimensions sent to the model. |
Union field
|
|
speechConfig |
Optional. The speech generation config. |
Union field
|
|
enableAffectiveDialog |
Optional. If enabled, the model will detect emotions and adapt its responses accordingly. For example, if the model detects that the user is frustrated, it may provide a more empathetic response. |
Union field
|
|
imageConfig |
Optional. Config for image generation features. Deprecated: Use |
Union field
|
|
audioTranscriptionConfig |
Optional. Config for audio transcription (speech recognition). |
Schema
| JSON representation |
|---|
{ "type": enum ( |
| Fields | |
|---|---|
type |
Optional. Data type of the schema field. |
format |
Optional. The format of the data. For |
title |
Optional. Title for the schema. |
description |
Optional. Describes the data. The model uses this field to understand the purpose of the schema and how to use it. It is a best practice to provide a clear and descriptive explanation for the schema and its properties here, rather than in the prompt. |
nullable |
Optional. Indicates if the value of this field can be null. |
default |
Optional. Default value to use if the field is not specified. |
items |
Optional. If type is |
minItems |
Optional. If type is |
maxItems |
Optional. If type is |
enum[] |
Optional. Possible values of the field. This field can be used to restrict a value to a fixed set of values. To mark a field as an enum, set |
properties |
Optional. If type is An object containing a list of |
propertyOrdering[] |
Optional. Order of properties displayed or used where order matters. This is not a standard field in OpenAPI specification, but can be used to control the order of properties. |
required[] |
Optional. If type is |
minProperties |
Optional. If type is |
maxProperties |
Optional. If type is |
minimum |
Optional. If type is |
maximum |
Optional. If type is |
minLength |
Optional. If type is |
maxLength |
Optional. If type is |
pattern |
Optional. If type is |
example |
Optional. Example of an instance of this schema. |
anyOf[] |
Optional. The instance must be valid against any (one or more) of the subschemas listed in |
additionalProperties |
Optional. If |
ref |
Optional. Allows referencing another schema definition to use in place of this schema. The value must be a valid reference to a schema in For example, the following schema defines a reference to a schema node named "Pet": type: object properties: pet: ref: #/defs/Pet defs: Pet: type: object properties: name: type: string The value of the "pet" property is a reference to the schema node named "Pet". See details in https://json-schema.org/understanding-json-schema/structuring |
defs |
Optional. An object containing a list of |
PropertiesEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
DefsEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
RoutingConfig
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field routing_config. The routing mode for the request. routing_config can be only one of the following: |
|
autoMode |
In this mode, the model is selected automatically based on the content of the request. |
manualMode |
In this mode, the model is specified manually. |
AutoRoutingMode
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
modelRoutingPreference |
The model routing preference. |
ManualRoutingMode
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
modelName |
The name of the model to use. Only public LLM models are accepted. |
SpeechConfig
| JSON representation |
|---|
{ "voiceConfig": { object ( |
| Fields | |
|---|---|
voiceConfig |
The configuration for the voice to use. |
languageCode |
Optional. The language code (ISO 639-1) for the speech synthesis. |
multiSpeakerVoiceConfig |
The configuration for a multi-speaker text-to-speech request. This field is mutually exclusive with |
VoiceConfig
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field voice_config. The configuration for the speaker to use. voice_config can be only one of the following: |
|
prebuiltVoiceConfig |
The configuration for a prebuilt voice. |
replicatedVoiceConfig |
Optional. The configuration for a replicated voice. This enables users to replicate a voice from an audio sample. |
PrebuiltVoiceConfig
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
voiceName |
The name of the prebuilt voice to use. |
ReplicatedVoiceConfig
| JSON representation |
|---|
{ "mimeType": string, "voiceSampleAudio": string } |
| Fields | |
|---|---|
mimeType |
Optional. The mimetype of the voice sample. The only currently supported value is |
voiceSampleAudio |
Optional. The sample of the custom voice. A base64-encoded string. |
MultiSpeakerVoiceConfig
| JSON representation |
|---|
{
"speakerVoiceConfigs": [
{
object ( |
| Fields | |
|---|---|
speakerVoiceConfigs[] |
Required. A list of configurations for the voices of the speakers. Exactly two speaker voice configurations must be provided. |
SpeakerVoiceConfig
| JSON representation |
|---|
{
"speaker": string,
"voiceConfig": {
object ( |
| Fields | |
|---|---|
speaker |
Required. The name of the speaker. This should be the same as the speaker name used in the prompt. |
voiceConfig |
Required. The configuration for the voice of this speaker. |
ThinkingConfig
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
includeThoughts |
Optional. If true, the model will include its thoughts in the response. "Thoughts" are the intermediate steps the model takes to arrive at the final response. They can provide insights into the model's reasoning process and help with debugging. If this is true, thoughts are returned only when available. |
Union field
|
|
thinkingBudget |
Optional. The token budget for the model's thinking process. The model will make a best effort to stay within this budget. This can be used to control the trade-off between response quality and latency. |
Union field
|
|
thinkingLevel |
Optional. The number of thoughts tokens that the model should generate. |
ModelConfig
| JSON representation |
|---|
{
"featureSelectionPreference": enum ( |
| Fields | |
|---|---|
featureSelectionPreference |
Required. Feature selection preference. |
ImageConfig
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
imageOutputOptions |
Optional. The image output format for generated images. |
Union field
|
|
aspectRatio |
Optional. The desired aspect ratio for the generated images. The following aspect ratios are supported: "1:1" "2:3", "3:2" "3:4", "4:3" "4:5", "5:4" "9:16", "16:9" "21:9" |
Union field
|
|
personGeneration |
Optional. Controls whether the model can generate people. |
Union field
|
|
imageSize |
Optional. Specifies the size of generated images. Supported values are |
ImageOutputOptions
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
mimeType |
Optional. The image format that the output should be saved as. |
Union field
|
|
compressionQuality |
Optional. The compression quality of the output image. |
ResponseFormat
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field format. The format of the output content. format can be only one of the following: |
|
text |
Text output format. |
audio |
Audio output format. |
image |
Image output format. |
video |
Video output format. |
TextResponseFormat
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
mimeType |
Optional. The IANA standard MIME type of the response. |
Union field
|
|
schema |
Optional. The JSON schema that the output should conform to. Only applicable when mime_type is APPLICATION_JSON. |
AudioResponseFormat
| JSON representation |
|---|
{ "delivery": enum ( |
| Fields | |
|---|---|
delivery |
Optional. Delivery mode for the generated content. |
Union field
|
|
mimeType |
Optional. The MIME type of the audio output. |
Union field
|
|
sampleRate |
Optional. Sample rate for the generated audio in Hertz. |
Union field
|
|
bitRate |
Optional. Bit rate in bits per second (bps). Only applicable for compressed formats (MP3, Opus). |
ImageResponseFormat
| JSON representation |
|---|
{ "delivery": enum ( |
| Fields | |
|---|---|
delivery |
Optional. Delivery mode for the generated content. |
Union field
|
|
mimeType |
Optional. The MIME type of the image output. |
Union field
|
|
aspectRatio |
Optional. The aspect ratio for the image output. |
Union field
|
|
imageSize |
Optional. The size of the image output. |
VideoResponseFormat
| JSON representation |
|---|
{ "delivery": enum ( |
| Fields | |
|---|---|
delivery |
Optional. Delivery mode for the generated content. |
gcsUri |
Optional. The Google Cloud Storage URI to store the video output. Required for Vertex if delivery is URI. |
aspectRatio |
The aspect ratio for the video output. |
Union field
|
|
duration |
Optional. The duration for the video output. A duration in seconds with up to nine fractional digits, ending with ' |
AudioTranscriptionConfig
| JSON representation |
|---|
{ "adaptationPhrases": [ string ], "customVocabulary": [ string ], "wordTimestamp": boolean, "diarization": boolean, // Union field |
| Fields | |
|---|---|
adaptationPhrases[] |
Optional. A list of phrases to bias the ASR model towards. |
customVocabulary[] |
Optional. A list of custom vocabulary phrases to bias the speech recognition model toward recognizing specific terms. |
wordTimestamp |
Optional. Configures word-level timestamp generation. |
diarization |
Optional. Configures speaker diarization. |
Union field language_config. Required. Specifies how to handle the languages in the audio. language_config can be only one of the following: |
|
languageAuto |
Optional. The model will detect the language automatically. |
languageHints |
Optional. Specifies one or more languages in the audio. |
LanguageHints
| JSON representation |
|---|
{ "languageCodes": [ string ] } |
| Fields | |
|---|---|
languageCodes[] |
Required. BCP-47 language codes. At least one must be specified. |
EvaluationParserConfig
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
customCodeParserConfig |
Optional. Use custom code to parse the LLM response. |
CustomCodeParserConfig
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
parsingFunction |
Required. Python function for parsing results. The function should be defined within this string. The function takes a list of strings (LLM responses) and should return either a list of dictionaries (for rubrics) or a single dictionary (for a metric result). Example function signature: def parse(responses: list[str]) -> list[dict[str, Any]] | dict[str, Any]: When parsing rubrics, return a list of dictionaries, where each dictionary represents a Rubric. Example for rubrics: [ { "content": {"property": {"description": "The response is factual."}}, "type": "FACTUALITY", "importance": "HIGH" }, { "content": {"property": {"description": "The response is fluent."}}, "type": "FLUENCY", "importance": "MEDIUM" } ] When parsing critique results, return a dictionary representing a MetricResult. Example for a metric result: { "score": 0.8, "explanation": "The model followed most instructions.", "rubric_verdicts": [...] } ... code for result extraction and aggregation |
CustomCodeExecutionSpec
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
evaluationFunction |
Required. Python function. Expected user to define the following function, e.g.: def evaluate(instance: dict[str, Any]) -> float: Please include this function signature in the code snippet. Instance is the evaluation instance, any fields populated in the instance are available to the function as instance[field_name]. Example: Example input:
Example converted input:
Example python function:
CustomCodeExecutionSpec is also supported in Batch Evaluation (EvalDataset RPC) and Tuning Evaluation. Each line in the input jsonl file will be converted to dict[str, Any] and passed to the evaluation function. |
MetricMetadata
| JSON representation |
|---|
{
"title": string,
"scoreRange": {
object ( |
| Fields | |
|---|---|
title |
Optional. The user-friendly name for the metric. If not set for a registered metric, it will default to the metric's display name. |
scoreRange |
Optional. The range of possible scores for this metric, used for plotting. |
otherMetadata |
Optional. Flexible metadata for user-defined attributes. |
ScoreRange
| JSON representation |
|---|
{ "description": string, // Union field |
| Fields | |
|---|---|
description |
Optional. The description of the score explaining the directionality etc. |
Union field
|
|
min |
Required. The minimum value of the score range (inclusive). |
Union field
|
|
max |
Required. The maximum value of the score range (inclusive). |
Union field
|
|
step |
Optional. The distance between discrete steps in the range. If unset, the range is assumed to be continuous. |
MetricSource
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field metric_source. The source of the metric. metric_source can be only one of the following: |
|
metric |
Inline metric config. |
metricResourceName |
Optional. Resource name for registered metric. |
EvaluationInstance
| JSON representation |
|---|
{ "prompt": { object ( |
| Fields | |
|---|---|
prompt |
Optional. Data used to populate placeholder |
rubricGroups |
Optional. Named groups of rubrics associated with the prompt. This is used for rubric-based evaluations where rubrics can be referenced by a key. The key could represent versions, associated metrics, etc. An object containing a list of |
response |
Optional. Data used to populate placeholder |
reference |
Optional. Data used to populate placeholder |
otherData |
Optional. Other data used to populate placeholders based on their key. If a key conflicts with a field in the EvaluationInstance (e.g. |
agentData |
Optional. Deprecated: Use |
agentEvalData |
Optional. Data used for agent evaluation. |
InstanceData
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field data. Supported formats for instance data. data can be only one of the following: |
|
text |
Text data. |
contents |
List of Gemini content data. |
Contents
| JSON representation |
|---|
{
"contents": [
{
object ( |
| Fields | |
|---|---|
contents[] |
Optional. Repeated contents. |
RubricGroupsEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
RubricGroup
| JSON representation |
|---|
{
"groupId": string,
"displayName": string,
"rubrics": [
{
object ( |
| Fields | |
|---|---|
groupId |
Unique identifier for the group. |
displayName |
Human-readable name for the group. This should be unique within a given context if used for display or selection. Example: "Instruction Following V1", "Content Quality - Summarization Task". |
rubrics[] |
Rubrics that are part of this group. |
Rubric
| JSON representation |
|---|
{ "rubricId": string, "content": { object ( |
| Fields | |
|---|---|
rubricId |
Unique identifier for the rubric. This ID is used to refer to this rubric, e.g., in RubricVerdict. |
content |
Required. The actual testable criteria for the rubric. |
Union field
|
|
type |
Optional. A type designator for the rubric, which can inform how it's evaluated or interpreted by systems or users. It's recommended to use consistent, well-defined, upper snake_case strings. Examples: "SUMMARIZATION_QUALITY", "SAFETY_HARMFUL_CONTENT", "INSTRUCTION_ADHERENCE". |
Union field
|
|
importance |
Optional. The relative importance of this rubric. |
Content
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
property |
Evaluation criteria based on a specific property. |
Property
| JSON representation |
|---|
{ "description": string } |
| Fields | |
|---|---|
description |
Description of the property being evaluated. Example: "The model's response is grammatically correct." |
MapInstance
| JSON representation |
|---|
{
"mapInstance": {
string: {
object ( |
| Fields | |
|---|---|
mapInstance |
Optional. Map of instance data. An object containing a list of |
MapInstanceEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
DeprecatedAgentData
| JSON representation |
|---|
{ "agents": { string: { object ( |
| Fields | |
|---|---|
agents |
Optional. The static Agent Configuration. This map defines the graph structure of the agent system. Key: agent_id (matches the An object containing a list of |
turns[] |
Optional. The chronological list of conversation turns. Each turn represents a logical execution cycle (e.g., User Input -> Agent Response). |
developerInstruction |
Optional. Deprecated: Use |
agentConfig |
Optional. Deprecated: Use |
Union field tools_data. --- Legacy fields below. To be deprecated. --- Deprecated: Use agents instead. Data for the tools available to the agent. tools_data can be only one of the following: |
|
toolsText |
A JSON string containing a list of tools available to an agent with info such as name, description, parameters and required parameters. |
tools |
List of tools. |
Union field
|
|
events |
A list of events. |
Tools
| JSON representation |
|---|
{
"tool": [
{
object ( |
| Fields | |
|---|---|
tool[] |
Optional. List of tools: each tool can have multiple function declarations. |
Tool
| JSON representation |
|---|
{ "functionDeclarations": [ { object ( |
| Fields | |
|---|---|
functionDeclarations[] |
Optional. Function tool type. One or more function declarations to be passed to the model along with the current user query. Model may decide to call a subset of these functions by populating |
retrieval |
Optional. Retrieval tool type. System will always execute the provided retrieval tool(s) to get external knowledge to answer the prompt. Retrieval results are presented to the model for generation. |
googleSearch |
Optional. GoogleSearch tool type. Tool to support Google Search in Model. Powered by Google. |
googleSearchRetrieval |
Optional. Specialized retrieval tool that is powered by Google Search. |
googleMaps |
Optional. GoogleMaps tool type. Tool to support Google Maps in Model. |
enterpriseWebSearch |
Optional. Tool to support searching public web data, powered by Agent Platform Search and Sec4 compliance. |
parallelAiSearch |
Optional. If specified, Agent Platform will use Parallel.ai to search for information to answer user queries. The search results will be grounded on Parallel.ai and presented to the model for response generation |
codeExecution |
Optional. CodeExecution tool type. Enables the model to execute code as part of generation. |
urlContext |
Optional. Tool to support URL context retrieval. |
computerUse |
Optional. Tool to support the model interacting directly with the computer. If enabled, it automatically populates computer-use specific Function Declarations. |
FunctionDeclaration
| JSON representation |
|---|
{ "name": string, "description": string, "parameters": { object ( |
| Fields | |
|---|---|
name |
Required. The name of the function to call. Must start with a letter or an underscore. Must be a-z, A-Z, 0-9, or contain underscores, dots, colons and dashes, with a maximum length of 128. |
description |
Optional. Description and purpose of the function. Model uses it to decide how and whether to call the function. |
parameters |
Optional. Describes the parameters to this function in JSON Schema Object format. Reflects the Open API 3.03 Parameter Object. string Key: the name of the parameter. Parameter names are case sensitive. Schema Value: the Schema defining the type used for the parameter. For function with no parameters, this can be left unset. Parameter names must start with a letter or an underscore and must only contain chars a-z, A-Z, 0-9, or underscores with a maximum length of 64. Example with 1 required and 1 optional parameter: type: OBJECT properties: param1: type: STRING param2: type: INTEGER required: - param1 |
parametersJsonSchema |
Optional. Describes the parameters to the function in JSON Schema format. The schema must describe an object where the properties are the parameters to the function. For example: This field is mutually exclusive with |
response |
Optional. Describes the output from this function in JSON Schema format. Reflects the Open API 3.03 Response Object. The Schema defines the type used for the response value of the function. |
responseJsonSchema |
Optional. Describes the output from this function in JSON Schema format. The value specified by the schema is the response value of the function. This field is mutually exclusive with |
Retrieval
| JSON representation |
|---|
{ "disableAttribution": boolean, // Union field |
| Fields | |
|---|---|
disableAttribution |
Optional. Deprecated. This option is no longer supported. |
Union field source. The source of the retrieval. source can be only one of the following: |
|
vertexAiSearch |
Set to use data source powered by Agent Platform Search. |
vertexRagStore |
Set to use data source powered by Vertex RAG store. User data is uploaded via the VertexRagDataService. |
VertexAISearch
| JSON representation |
|---|
{
"datastore": string,
"engine": string,
"maxResults": integer,
"filter": string,
"dataStoreSpecs": [
{
object ( |
| Fields | |
|---|---|
datastore |
Optional. Fully-qualified Agent Platform Search data store resource ID. Format: |
engine |
Optional. Fully-qualified Agent Platform Search engine resource ID. Format: |
maxResults |
Optional. Number of search results to return per query. The default value is 10. The maximumm allowed value is 10. |
filter |
Optional. Filter strings to be passed to the search API. |
dataStoreSpecs[] |
Specifications that define the specific DataStores to be searched, along with configurations for those data stores. This is only considered for Engines with multiple data stores. It should only be set if engine is used. |
DataStoreSpec
| JSON representation |
|---|
{ "dataStore": string, "filter": string } |
| Fields | |
|---|---|
dataStore |
Full resource name of DataStore, such as Format: |
filter |
Optional. Filter specification to filter documents in the data store specified by data_store field. For more information on filtering, see Filtering |
VertexRagStore
| JSON representation |
|---|
{ "ragCorpora": [ string ], "ragResources": [ { object ( |
| Fields | |
|---|---|
ragCorpora[] |
Optional. Deprecated. Please use rag_resources instead. |
ragResources[] |
Optional. The representation of the rag source. It can be used to specify corpus only or ragfiles. Currently only support one corpus or multiple files from one corpus. In the future we may open up multiple corpora support. |
ragRetrievalConfig |
Optional. The retrieval config for the Rag query. |
storeContext |
Optional. Currently only supported for Gemini Multimodal Live API. In Gemini Multimodal Live API, if |
Union field
|
|
similarityTopK |
Optional. Number of top k results to return from the selected corpora. |
Union field
|
|
vectorDistanceThreshold |
Optional. Only return results with vector distance smaller than the threshold. |
RagResource
| JSON representation |
|---|
{ "ragCorpus": string, "ragFileIds": [ string ] } |
| Fields | |
|---|---|
ragCorpus |
Optional. RagCorpora resource name. Format: |
ragFileIds[] |
Optional. rag_file_id. The files should be in the same rag_corpus set in rag_corpus field. |
RagRetrievalConfig
| JSON representation |
|---|
{ "topK": integer, "hybridSearch": { object ( |
| Fields | |
|---|---|
topK |
Optional. The number of contexts to retrieve. |
hybridSearch |
Optional. Config for Hybrid Search. |
filter |
Optional. Config for filters. |
ranking |
Optional. Config for ranking and reranking. |
HybridSearch
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
alpha |
Optional. Alpha value controls the weight between dense and sparse vector search results. The range is [0, 1], while 0 means sparse vector search only and 1 means dense vector search only. The default value is 0.5 which balances sparse and dense vector search equally. |
Filter
| JSON representation |
|---|
{ "metadataFilter": string, // Union field |
| Fields | |
|---|---|
metadataFilter |
Optional. String for metadata filtering. |
Union field vector_db_threshold. Filter contexts retrieved from the vector DB based on either vector distance or vector similarity. vector_db_threshold can be only one of the following: |
|
vectorDistanceThreshold |
Optional. Only returns contexts with vector distance smaller than the threshold. |
vectorSimilarityThreshold |
Optional. Only returns contexts with vector similarity larger than the threshold. |
Ranking
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field ranking_config. Config options for ranking. Currently only Rank Service is supported. ranking_config can be only one of the following: |
|
rankService |
Optional. Config for Rank Service. |
llmRanker |
Optional. Config for LlmRanker. |
RankService
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
modelName |
Optional. The model name of the rank service. Format: |
LlmRanker
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
modelName |
Optional. The model name used for ranking. See Supported models. |
GoogleSearch
| JSON representation |
|---|
{ "excludeDomains": [ string ], // Union field |
| Fields | |
|---|---|
excludeDomains[] |
Optional. List of domains to be excluded from the search results. The default limit is 2000 domains. Example: ["amazon.com", "facebook.com"]. |
Union field
|
|
blockingConfidence |
Optional. Sites with confidence level chosen & above this value will be blocked from the search results. |
GoogleSearchRetrieval
| JSON representation |
|---|
{
"dynamicRetrievalConfig": {
object ( |
| Fields | |
|---|---|
dynamicRetrievalConfig |
Specifies the dynamic retrieval configuration for the given source. |
DynamicRetrievalConfig
| JSON representation |
|---|
{ "mode": enum ( |
| Fields | |
|---|---|
mode |
The mode of the predictor to be used in dynamic retrieval. |
Union field
|
|
dynamicThreshold |
Optional. The threshold to be used in dynamic retrieval. If not set, a system default value is used. |
GoogleMaps
| JSON representation |
|---|
{
"enableWidget": boolean,
"groundingTypes": {
object ( |
| Fields | |
|---|---|
enableWidget |
Optional. Deprecated: The Google Maps contextual widget behavior in Grounding with Google Maps is being deprecated; this field is planned for removal and no longer has any effect once removed. If true, include the widget context token in the response. |
groundingTypes |
Optional. Specifies the types of Google Maps grounding to enable. Defaults to |
GroundingTypes
| JSON representation |
|---|
{ "places": { object ( |
| Fields | |
|---|---|
places |
Optional. Enables grounding with Google Maps Places. This is the default grounding type when no |
routing |
Optional. Enables grounding with Google Maps Routing APIs (ComputeRoutes and SearchAlongRoute). |
EnterpriseWebSearch
| JSON representation |
|---|
{ "excludeDomains": [ string ], // Union field |
| Fields | |
|---|---|
excludeDomains[] |
Optional. List of domains to be excluded from the search results. The default limit is 2000 domains. |
Union field
|
|
blockingConfidence |
Optional. Sites with confidence level chosen & above this value will be blocked from the search results. |
ParallelAiSearch
| JSON representation |
|---|
{ "apiKey": string, "customConfigs": { object } } |
| Fields | |
|---|---|
apiKey |
Optional. The API key for ParallelAiSearch. If an API key is not provided, the system will attempt to verify access by checking for an active Parallel.ai subscription through the Google Cloud Marketplace. See https://docs.parallel.ai/search/search-quickstart for more details. |
customConfigs |
Optional. Custom configs for ParallelAiSearch. This field can be used to pass any parameter from the Parallel.ai Search API. See the Parallel.ai documentation for the full list of available parameters and their usage: https://docs.parallel.ai/api-reference/search-beta/search Currently only |
ComputerUse
| JSON representation |
|---|
{
"environment": enum ( |
| Fields | |
|---|---|
environment |
Required. The environment being operated. |
excludedPredefinedFunctions[] |
Optional. By default, predefined functions are included in the final model call. Some of them can be explicitly excluded from being automatically included. This can serve two purposes: 1. Using a more restricted / different action space. 2. Improving the definitions / instructions of predefined functions. |
Events
| JSON representation |
|---|
{
"event": [
{
object ( |
| Fields | |
|---|---|
event[] |
Optional. A list of events. |
AgentsEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
DeprecatedAgentConfig
| JSON representation |
|---|
{ "agentId": string, "agentType": string, "description": string, "subAgents": [ string ], "developerInstruction": { object ( |
| Fields | |
|---|---|
agentId |
Optional. Unique identifier of the agent. This ID is used to refer to this agent, e.g., in AgentEvent.author, or in the |
agentType |
Optional. The type or class of the agent (e.g., "LlmAgent", "RouterAgent", "ToolUseAgent"). Useful for the autorater to understand the expected behavior of the agent. |
description |
Optional. A high-level description of the agent's role and responsibilities. Critical for evaluating if the agent is routing tasks correctly. |
subAgents[] |
Optional. The list of valid agent IDs (names) that this agent can delegate to. This defines the directed edges in the agent system graph topology. |
developerInstruction |
Optional. Contains instructions from the developer for the agent. Can be static or a dynamic prompt template used with the |
Union field tools_data. Data for the tools available to the agent. tools_data can be only one of the following: |
|
toolsText |
A JSON string containing a list of tools available to an agent with info such as name, description, parameters and required parameters. |
tools |
List of tools. |
Tools
| JSON representation |
|---|
{
"tool": [
{
object ( |
| Fields | |
|---|---|
tool[] |
Optional. List of tools: each tool can have multiple function declarations. |
ConversationTurn
| JSON representation |
|---|
{ "turnId": string, "events": [ { object ( |
| Fields | |
|---|---|
turnId |
Optional. A unique identifier for the turn. Useful for referencing specific turns across systems. |
events[] |
Optional. The list of events that occurred during this turn. |
Union field
|
|
turnIndex |
Required. The 0-based index of the turn in the conversation sequence. |
AgentEvent
| JSON representation |
|---|
{ "content": { object ( |
| Fields | |
|---|---|
content |
Required. The content of the event (e.g., text response, tool call, tool response). |
eventTime |
Optional. The timestamp when the event occurred. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
stateDelta |
Optional. The change in the session state caused by this event. This is a key-value map of fields that were modified or added by the event. |
activeTools[] |
Optional. The list of tools that were active/available to the agent at the time of this event. This overrides the |
Union field
|
|
author |
Required. The ID of the agent or entity that generated this event. |
Timestamp
| JSON representation |
|---|
{ "seconds": string, "nanos": integer } |
| Fields | |
|---|---|
seconds |
Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z). |
nanos |
Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive. |
AgentData
| JSON representation |
|---|
{ "agents": { string: { object ( |
| Fields | |
|---|---|
agents |
Optional. A map containing the static configurations for each agent in the system. Key: agent_id (matches the An object containing a list of |
turns[] |
Optional. A chronological list of conversation turns. Each turn represents a logical execution cycle (e.g., User Input -> Agent Response). |
AgentsEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
AgentConfig
| JSON representation |
|---|
{ "agentType": string, "description": string, "instruction": string, "tools": [ { object ( |
| Fields | |
|---|---|
agentType |
Optional. The type or class of the agent (e.g., "LlmAgent", "RouterAgent", "ToolUseAgent"). Useful for the autorater to understand the expected behavior of the agent. |
description |
Optional. A high-level description of the agent's role and responsibilities. Critical for evaluating if the agent is routing tasks correctly. |
instruction |
Optional. Provides instructions for the LLM model, guiding the agent's behavior. Can be static or dynamic. Dynamic instructions can contain placeholders like {variable_name} that will be resolved at runtime using the |
tools[] |
Optional. The list of tools available to this agent. |
subAgents[] |
Optional. The list of valid agent IDs that this agent can delegate to. This defines the directed edges in the multi-agent system graph topology. |
Union field
|
|
agentId |
Required. Unique identifier of the agent. This ID is used to refer to this agent, e.g., in AgentEvent.author, or in the |
ConversationTurn
| JSON representation |
|---|
{ "turnId": string, "events": [ { object ( |
| Fields | |
|---|---|
turnId |
Optional. A unique identifier for the turn. Useful for referencing specific turns across systems. |
events[] |
Optional. The list of events that occurred during this turn. |
Union field
|
|
turnIndex |
Required. The 0-based index of the turn in the conversation sequence. |
AgentEvent
| JSON representation |
|---|
{ "eventTime": string, "stateDelta": { object }, "activeTools": [ { object ( |
| Fields | |
|---|---|
eventTime |
Optional. The timestamp when the event occurred. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
stateDelta |
Optional. The change in the session state caused by this event. This is a key-value map of fields that were modified or added by the event. |
activeTools[] |
Optional. The list of tools that were active/available to the agent at the time of this event. This overrides the |
Union field
|
|
author |
Required. The ID of the agent or entity that generated this event. Use "user" to denote events generated by the end-user. |
Union field
|
|
content |
Required. The content of the event (e.g., text response, tool call, tool response). |
NullValue
Represents a JSON null.
NullValue is a sentinel, using an enum with only one value to represent the null value for the Value type union.
A field of type NullValue with any value other than 0 is considered invalid. Most ProtoJSON serializers will emit a Value with a null_value set as a JSON null regardless of the integer value, and so will round trip to a 0 value.
| Enums | |
|---|---|
NULL_VALUE |
Null value. |
Language
Supported programming languages for the generated code.
| Enums | |
|---|---|
LANGUAGE_UNSPECIFIED |
Unspecified language. This value should not be used. |
PYTHON |
Python >= 3.10, with numpy and simpy available. |
Outcome
Enumeration of possible outcomes of the code execution.
| Enums | |
|---|---|
OUTCOME_UNSPECIFIED |
Unspecified status. This value should not be used. |
OUTCOME_OK |
Code execution completed successfully. output contains the stdout, if any. |
OUTCOME_FAILED |
Code execution failed. output contains the stderr and stdout, if any. |
OUTCOME_DEADLINE_EXCEEDED |
Code execution ran for too long, and was cancelled. There may or may not be a partial output present. |
Level
The media resolution level.
| Enums | |
|---|---|
MEDIA_RESOLUTION_UNSPECIFIED |
Media resolution has not been set. |
MEDIA_RESOLUTION_LOW |
Media resolution set to low. |
MEDIA_RESOLUTION_MEDIUM |
Media resolution set to medium. |
MEDIA_RESOLUTION_HIGH |
Media resolution set to high. |
MEDIA_RESOLUTION_ULTRA_HIGH |
Media resolution set to ultra high. This is for image only. |
CometVersion
Comet version options.
| Enums | |
|---|---|
COMET_VERSION_UNSPECIFIED |
Comet version unspecified. |
COMET_22_SRC_REF |
Comet 22 for translation + source + reference (source-reference-combined). |
MetricxVersion
MetricX Version options.
| Enums | |
|---|---|
METRICX_VERSION_UNSPECIFIED |
MetricX version unspecified. |
METRICX_24_REF |
MetricX 2024 (2.6) for translation + reference (reference-based). |
METRICX_24_SRC |
MetricX 2024 (2.6) for translation + source (QE). |
METRICX_24_SRC_REF |
MetricX 2024 (2.6) for translation + source + reference (source-reference-combined). |
ComputationBasedMetricType
Types of computation based metrics.
| Enums | |
|---|---|
COMPUTATION_BASED_METRIC_TYPE_UNSPECIFIED |
Unspecified computation based metric type. |
EXACT_MATCH |
Exact match metric. |
BLEU |
BLEU metric. |
ROUGE |
ROUGE metric. |
Type
Type contains the list of OpenAPI data types as defined by https://swagger.io/docs/specification/data-models/data-types/
| Enums | |
|---|---|
TYPE_UNSPECIFIED |
Not specified, should not be used. |
STRING |
OpenAPI string type |
NUMBER |
OpenAPI number type |
INTEGER |
OpenAPI integer type |
BOOLEAN |
OpenAPI boolean type |
ARRAY |
OpenAPI array type |
OBJECT |
OpenAPI object type |
NULL |
Null type |
ModelRoutingPreference
The model routing preference.
| Enums | |
|---|---|
UNKNOWN |
Unspecified model routing preference. |
PRIORITIZE_QUALITY |
The model will be selected to prioritize the quality of the response. |
BALANCED |
The model will be selected to balance quality and cost. |
PRIORITIZE_COST |
The model will be selected to prioritize the cost of the request. |
Modality
The modalities of the response.
| Enums | |
|---|---|
MODALITY_UNSPECIFIED |
Unspecified modality. Will be processed as text. |
TEXT |
Text modality. |
IMAGE |
Image modality. |
AUDIO |
Audio modality. |
VIDEO |
Video modality. |
MediaResolution
Media resolution for the input media.
| Enums | |
|---|---|
MEDIA_RESOLUTION_UNSPECIFIED |
Media resolution has not been set. |
MEDIA_RESOLUTION_LOW |
Media resolution set to low (64 tokens). |
MEDIA_RESOLUTION_MEDIUM |
Media resolution set to medium (256 tokens). |
MEDIA_RESOLUTION_HIGH |
Media resolution set to high (zoomed reframing with 256 tokens). |
ThinkingLevel
The thinking level for the model.
| Enums | |
|---|---|
THINKING_LEVEL_UNSPECIFIED |
Unspecified thinking level. |
LOW |
Low thinking level. |
MEDIUM |
Medium thinking level. |
HIGH |
High thinking level. |
MINIMAL |
MINIMAL thinking level. |
FeatureSelectionPreference
Options for feature selection preference.
| Enums | |
|---|---|
FEATURE_SELECTION_PREFERENCE_UNSPECIFIED |
Unspecified feature selection preference. |
PRIORITIZE_QUALITY |
Prefer higher quality over lower cost. |
BALANCED |
Balanced feature selection preference. |
PRIORITIZE_COST |
Prefer lower cost over higher quality. |
PersonGeneration
Enum for controlling the generation of people in images.
| Enums | |
|---|---|
PERSON_GENERATION_UNSPECIFIED |
The default behavior is unspecified. The model will decide whether to generate images of people. |
ALLOW_ALL |
Allows the model to generate images of people, including adults and children. |
ALLOW_ADULT |
Allows the model to generate images of adults, but not children. |
ALLOW_NONE |
Prevents the model from generating images of people. |
MimeType
Supported MIME types for text output.
| Enums | |
|---|---|
MIME_TYPE_UNSPECIFIED |
Default value. This value is unused. |
APPLICATION_JSON |
JSON output format. |
TEXT_PLAIN |
Plain text output format. |
MimeType
Supported MIME types for audio output.
| Enums | |
|---|---|
MIME_TYPE_UNSPECIFIED |
Default value. This value is unused. |
AUDIO_MP3 |
MP3 audio format. |
AUDIO_OGG_OPUS |
OGG Opus audio format. |
AUDIO_L16 |
Raw PCM (L16) audio format. |
AUDIO_WAV |
WAV audio format. |
AUDIO_ALAW |
A-law audio format. |
AUDIO_MULAW |
Mu-law audio format. |
DeliveryMode
The delivery mode for the output content.
| Enums | |
|---|---|
DELIVERY_UNSPECIFIED |
Default value. This value is unused. |
INLINE |
Generated bytes are returned inline in the response. |
URI |
Generated content is stored and a URI is returned. |
MimeType
Supported MIME types for image output.
| Enums | |
|---|---|
MIME_TYPE_UNSPECIFIED |
Default value. This value is unused. |
IMAGE_JPEG |
JPEG image format. |
AspectRatio
Supported aspect ratios for image output.
| Enums | |
|---|---|
ASPECT_RATIO_UNSPECIFIED |
Default value. This value is unused. |
ASPECT_RATIO_ONE_BY_ONE |
1:1 aspect ratio. |
ASPECT_RATIO_TWO_BY_THREE |
2:3 aspect ratio. |
ASPECT_RATIO_THREE_BY_TWO |
3:2 aspect ratio. |
ASPECT_RATIO_THREE_BY_FOUR |
3:4 aspect ratio. |
ASPECT_RATIO_FOUR_BY_THREE |
4:3 aspect ratio. |
ASPECT_RATIO_FOUR_BY_FIVE |
4:5 aspect ratio. |
ASPECT_RATIO_FIVE_BY_FOUR |
5:4 aspect ratio. |
ASPECT_RATIO_NINE_BY_SIXTEEN |
9:16 aspect ratio. |
ASPECT_RATIO_SIXTEEN_BY_NINE |
16:9 aspect ratio. |
ASPECT_RATIO_TWENTY_ONE_BY_NINE |
21:9 aspect ratio. |
ASPECT_RATIO_ONE_BY_EIGHT |
1:8 aspect ratio. |
ASPECT_RATIO_EIGHT_BY_ONE |
8:1 aspect ratio. |
ASPECT_RATIO_ONE_BY_FOUR |
1:4 aspect ratio. |
ASPECT_RATIO_FOUR_BY_ONE |
4:1 aspect ratio. |
ImageSize
Supported image sizes for image output.
| Enums | |
|---|---|
IMAGE_SIZE_UNSPECIFIED |
Default value. This value is unused. |
IMAGE_SIZE_FIVE_TWELVE |
512px image size. |
IMAGE_SIZE_ONE_K |
1K image size. |
IMAGE_SIZE_TWO_K |
2K image size. |
IMAGE_SIZE_FOUR_K |
4K image size. |
AspectRatio
Supported aspect ratios for video output.
| Enums | |
|---|---|
ASPECT_RATIO_UNSPECIFIED |
Default value. This value is unused. |
ASPECT_RATIO_SIXTEEN_BY_NINE |
16:9 aspect ratio. |
ASPECT_RATIO_NINE_BY_SIXTEEN |
9:16 aspect ratio. |
RubricContentType
Specifies the type of rubric content to generate.
| Enums | |
|---|---|
RUBRIC_CONTENT_TYPE_UNSPECIFIED |
The content type to generate is not specified. |
PROPERTY |
Generate rubrics based on properties. |
NL_QUESTION_ANSWER |
Generate rubrics in an NL question answer format. |
PYTHON_CODE_ASSERTION |
Generate rubrics in a unit test format. |
AggregationMetric
The per-metric statistics on evaluation results supported by EvaluationService.EvaluateDataset.
| Enums | |
|---|---|
AGGREGATION_METRIC_UNSPECIFIED |
Unspecified aggregation metric. |
AVERAGE |
Average aggregation metric. Not supported for Pairwise metric. |
MODE |
Mode aggregation metric. |
STANDARD_DEVIATION |
Standard deviation aggregation metric. Not supported for pairwise metric. |
VARIANCE |
Variance aggregation metric. Not supported for pairwise metric. |
MINIMUM |
Minimum aggregation metric. Not supported for pairwise metric. |
MAXIMUM |
Maximum aggregation metric. Not supported for pairwise metric. |
MEDIAN |
Median aggregation metric. Not supported for pairwise metric. |
PERCENTILE_P90 |
90th percentile aggregation metric. Not supported for pairwise metric. |
PERCENTILE_P95 |
95th percentile aggregation metric. Not supported for pairwise metric. |
PERCENTILE_P99 |
99th percentile aggregation metric. Not supported for pairwise metric. |
Importance
Importance level of the rubric.
| Enums | |
|---|---|
IMPORTANCE_UNSPECIFIED |
Importance is not specified. |
HIGH |
High importance. |
MEDIUM |
Medium importance. |
LOW |
Low importance. |
PhishBlockThreshold
These are available confidence level user can set to block malicious urls with chosen confidence and above. For understanding different confidence of webrisk, please refer to https://cloud.google.com/web-risk/docs/reference/rpc/google.cloud.webrisk.v1eap1#confidencelevel
| Enums | |
|---|---|
PHISH_BLOCK_THRESHOLD_UNSPECIFIED |
Defaults to unspecified. |
BLOCK_LOW_AND_ABOVE |
Blocks Low and above confidence URL that is risky. |
BLOCK_MEDIUM_AND_ABOVE |
Blocks Medium and above confidence URL that is risky. |
BLOCK_HIGH_AND_ABOVE |
Blocks High and above confidence URL that is risky. |
BLOCK_HIGHER_AND_ABOVE |
Blocks Higher and above confidence URL that is risky. |
BLOCK_VERY_HIGH_AND_ABOVE |
Blocks Very high and above confidence URL that is risky. |
BLOCK_ONLY_EXTREMELY_HIGH |
Blocks Extremely high confidence URL that is risky. |
Mode
The mode of the predictor to be used in dynamic retrieval.
| Enums | |
|---|---|
MODE_UNSPECIFIED |
Always trigger retrieval. |
MODE_DYNAMIC |
Run retrieval only when system decides it is necessary. |
Environment
Represents the environment being operated, such as a web browser.
| Enums | |
|---|---|
ENVIRONMENT_UNSPECIFIED |
Defaults to browser. |
ENVIRONMENT_BROWSER |
Operates in a web browser. |
Output Schema
Response message for EvaluationService.EvaluateInstances.
EvaluateInstancesResponse
| JSON representation |
|---|
{ "metricResults": [ { object ( |
| Fields | |
|---|---|
metricResults[] |
Metric results for each instance. The order of the metric results is guaranteed to be the same as the order of the instances in the request. |
Union field evaluation_results. Evaluation results will be served in the same order as presented in EvaluationRequest.instances. evaluation_results can be only one of the following: |
|
exactMatchResults |
Auto metric evaluation results. Results for exact match metric. |
bleuResults |
Results for bleu metric. |
rougeResults |
Results for rouge metric. |
fluencyResult |
LLM-based metric evaluation result. General text generation metrics, applicable to other categories. Result for fluency metric. |
coherenceResult |
Result for coherence metric. |
safetyResult |
Result for safety metric. |
groundednessResult |
Result for groundedness metric. |
fulfillmentResult |
Result for fulfillment metric. |
summarizationQualityResult |
Summarization only metrics. Result for summarization quality metric. |
pairwiseSummarizationQualityResult |
Result for pairwise summarization quality metric. |
summarizationHelpfulnessResult |
Result for summarization helpfulness metric. |
summarizationVerbosityResult |
Result for summarization verbosity metric. |
questionAnsweringQualityResult |
Question answering only metrics. Result for question answering quality metric. |
pairwiseQuestionAnsweringQualityResult |
Result for pairwise question answering quality metric. |
questionAnsweringRelevanceResult |
Result for question answering relevance metric. |
questionAnsweringHelpfulnessResult |
Result for question answering helpfulness metric. |
questionAnsweringCorrectnessResult |
Result for question answering correctness metric. |
pointwiseMetricResult |
Generic metrics. Result for pointwise metric. |
pairwiseMetricResult |
Result for pairwise metric. |
toolCallValidResults |
Tool call metrics. Results for tool call valid metric. |
toolNameMatchResults |
Results for tool name match metric. |
toolParameterKeyMatchResults |
Results for tool parameter key match metric. |
toolParameterKvMatchResults |
Results for tool parameter key value match metric. |
cometResult |
Translation metrics. Result for Comet metric. |
metricxResult |
Result for Metricx metric. |
trajectoryExactMatchResults |
Result for trajectory exact match metric. |
trajectoryInOrderMatchResults |
Result for trajectory in order match metric. |
trajectoryAnyOrderMatchResults |
Result for trajectory any order match metric. |
trajectoryPrecisionResults |
Result for trajectory precision metric. |
trajectoryRecallResults |
Results for trajectory recall metric. |
trajectorySingleToolUseResults |
Results for trajectory single tool use metric. |
rubricBasedInstructionFollowingResult |
Result for rubric based instruction following metric. |
ExactMatchResults
| JSON representation |
|---|
{
"exactMatchMetricValues": [
{
object ( |
| Fields | |
|---|---|
exactMatchMetricValues[] |
Output only. Exact match metric values. |
ExactMatchMetricValue
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
score |
Output only. Exact match score. |
BleuResults
| JSON representation |
|---|
{
"bleuMetricValues": [
{
object ( |
| Fields | |
|---|---|
bleuMetricValues[] |
Output only. Bleu metric values. |
BleuMetricValue
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
score |
Output only. Bleu score. |
RougeResults
| JSON representation |
|---|
{
"rougeMetricValues": [
{
object ( |
| Fields | |
|---|---|
rougeMetricValues[] |
Output only. Rouge metric values. |
RougeMetricValue
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
score |
Output only. Rouge score. |
FluencyResult
| JSON representation |
|---|
{ "explanation": string, // Union field |
| Fields | |
|---|---|
explanation |
Output only. Explanation for fluency score. |
Union field
|
|
score |
Output only. Fluency score. |
Union field
|
|
confidence |
Output only. Confidence for fluency score. |
CoherenceResult
| JSON representation |
|---|
{ "explanation": string, // Union field |
| Fields | |
|---|---|
explanation |
Output only. Explanation for coherence score. |
Union field
|
|
score |
Output only. Coherence score. |
Union field
|
|
confidence |
Output only. Confidence for coherence score. |
SafetyResult
| JSON representation |
|---|
{ "explanation": string, // Union field |
| Fields | |
|---|---|
explanation |
Output only. Explanation for safety score. |
Union field
|
|
score |
Output only. Safety score. |
Union field
|
|
confidence |
Output only. Confidence for safety score. |
GroundednessResult
| JSON representation |
|---|
{ "explanation": string, // Union field |
| Fields | |
|---|---|
explanation |
Output only. Explanation for groundedness score. |
Union field
|
|
score |
Output only. Groundedness score. |
Union field
|
|
confidence |
Output only. Confidence for groundedness score. |
FulfillmentResult
| JSON representation |
|---|
{ "explanation": string, // Union field |
| Fields | |
|---|---|
explanation |
Output only. Explanation for fulfillment score. |
Union field
|
|
score |
Output only. Fulfillment score. |
Union field
|
|
confidence |
Output only. Confidence for fulfillment score. |
SummarizationQualityResult
| JSON representation |
|---|
{ "explanation": string, // Union field |
| Fields | |
|---|---|
explanation |
Output only. Explanation for summarization quality score. |
Union field
|
|
score |
Output only. Summarization Quality score. |
Union field
|
|
confidence |
Output only. Confidence for summarization quality score. |
PairwiseSummarizationQualityResult
| JSON representation |
|---|
{ "pairwiseChoice": enum ( |
| Fields | |
|---|---|
pairwiseChoice |
Output only. Pairwise summarization prediction choice. |
explanation |
Output only. Explanation for summarization quality score. |
Union field
|
|
[...]
